# Include file for Makefile for HuC
# Written for unified version, October 16, 2001 by Dave Shadoff 
#
# This file set initial defines, both general and platform-specific
#


#
# general stuff
#
CC=gcc
CDEFS =
CFLAGS = -Werror -Wall -g
LDFLAGS = -g

#
# platform-specific stuff
#
ifeq "$(origin DJGPP)" "undefined"

# BASEDIR uses 'd' for path separator; we fix that here
#
ROOTDIR=$(subst d ,/,$(BASEDIR))
BINDIR=$(ROOTDIR)/bin
MAKETARG=$(ROOTDIR)/src/Maketarg.inc
TOOLDIR=$(ROOTDIR)/src/tools
GETOPTDIR=$(TOOLDIR)/getopt/
EXESUFFIX = 
CP = cp
RM = rm -f
MKDIR = mkdir

#ifneq (,$(findstring MINGW32,$(shell uname -s)))
ifneq (,$(findstring mingw32, $(CC) -dumpmachine))
HAVE_GETOPT=0
else
HAVE_GETOPT=1
endif

else

# BASEDIR uses 'd' for path separator; we fix that here
#
ROOTDIR=$(subst d ,\,$(BASEDIR))
BINDIR=$(ROOTDIR)\bin
MAKETARG=$(ROOTDIR)\src\Maketarg.inc
TOOLDIR=$(ROOTDIR)\src\tools
GETOPTDIR=$(TOOLDIR)\getopt\
EXESUFFIX = .exe
CP = copy
RM = del
HAVE_GETOPT=0

endif
