/*	File expr.c: 2.2 (83/06/21,11:24:26) */
/*% cc -O -c %
 *
 */

#include <stdio.h>
#include <string.h>
#include "defs.h"
#include "data.h"
#include "code.h"
#include "error.h"
#include "expr.h"
#include "function.h"
#include "gen.h"
#include "io.h"
#include "lex.h"
#include "primary.h"


/*
 *	lval[0] - symbol table address, else 0 for constant
 *	lval[1] - type indirect object to fetch, else 0 for static object
 *	lval[2] - type pointer or array, else 0
 */

void expression (int comma)
{
	expr_data_t	lval;

	do {
		if (heir1 (&lval))
			rvalue (&lval);
		if (!comma)
			return;
	} while (match (","));
}

int heir1 (expr_data_t * lval)
{
	int	k;
	expr_data_t lval2;
	char	fc;

	k = heir1a (lval);
	if (match ("=")) {
		if (k == 0) {
			needlval ();
			return (0);
		}
		if (lval->type)
			gpush ();
		if (heir1 (&lval2))
			rvalue (&lval2);
		store (lval);
		return (0);
	} else
	{	
		fc = ch();
		if  (match ("-=") ||
		    match ("+=") ||
		    match ("*=") ||
		    match ("/=") ||
		    match ("%=") ||
		    match (">>=") ||
		    match ("<<=") ||
		    match ("&=") ||
		    match ("^=") ||
		    match ("|=")) {
			if (k == 0) {
				needlval ();
				return (0);
			}
			if (lval->type)
				gpush ();
			rvalue (lval);
			gpush ();
			if (heir1 (&lval2))
				rvalue (&lval2);
			switch (fc) {
				case '-':	{
					if (dbltest(lval,&lval2))
						gaslint();
					gsub();
					result (lval, &lval2);
					break;
				}
				case '+':	{
					if (dbltest(lval,&lval2))
						gaslint();
					gadd (lval,&lval2);
					result(lval,&lval2);
					break;
				}
				case '*':	gmult (); break;
				case '/':	gdiv (); break;
				case '%':	gmod (); break;
				case '>':	gasr (); break;
				case '<':	gasl (); break;
				case '&':	gand (); break;
				case '^':	gxor (); break;
				case '|':	gor (); break;
			}
			store (lval);
			return (0);
		} else
			return (k);
	}
}

int heir1a (expr_data_t *lval)
{
	int	k, lab1, lab2;
	expr_data_t lval2;

	k = heir1b (lval);
	blanks ();
	if (ch () != '?')
		return (k);
	if (k)
		rvalue (lval);
	FOREVER
		if (match ("?")) {
			testjump (lab1 = getlabel (), FALSE);
			if (heir1b (&lval2))
				rvalue (&lval2);
			jump (lab2 = getlabel ());
			gnlabel (lab1);
			blanks ();
			if (!match (":")) {
				error ("missing colon");
				return (0);
			}
			if (heir1b (&lval2))
				rvalue (&lval2);
			gnlabel (lab2);
		} else
			return (0);
}

int heir1b (expr_data_t *lval)
{
	int	k, lab;
	expr_data_t lval2;

	k = heir1c (lval);
	blanks ();
	if (!sstreq ("||"))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER
		if (match ("||")) {
			testjump (lab = getlabel (), TRUE);
			if (heir1c (&lval2))
				rvalue (&lval2);
			gnlabel (lab);
			gbool();
		} else
			return (0);
}

int heir1c (expr_data_t *lval)
{
	int	k, lab;
	expr_data_t lval2;

	k = heir2 (lval);
	blanks ();
	if (!sstreq ("&&"))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER
		if (match ("&&")) {
			testjump (lab = getlabel (), FALSE);
			if (heir2 (&lval2))
				rvalue (&lval2);
			gnlabel (lab);
			gbool();
		} else
			return (0);
}

int heir2 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir3 (lval);
	blanks ();
	if ((ch() != '|') | (nch() == '|') | (nch() == '='))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if ((ch() == '|') & (nch() != '|') & (nch() != '=')) {
			inbyte ();
			gpush ();
			if (heir3 (&lval2))
				rvalue (&lval2);
			gor ();
			blanks();
		} else
			return (0);
	}
}

int heir3 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir4 (lval);
	blanks ();
	if ((ch () != '^') | (nch() == '='))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if ((ch() == '^') & (nch() != '=')){
			inbyte ();
			gpush ();
			if (heir4 (&lval2))
				rvalue (&lval2);
			gxor ();
			blanks();
		} else
			return (0);
	}
}

int heir4 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir5 (lval);
	blanks ();
	if ((ch() != '&') | (nch() == '|') | (nch() == '='))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if ((ch() == '&') & (nch() != '&') & (nch() != '=')) {
			inbyte ();
			gpush ();
			if (heir5 (&lval2))
				rvalue (&lval2);
			gand ();
			blanks();
		} else
			return (0);
	}
}

int heir5 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir6 (lval);
	blanks ();
	if (!sstreq ("==") &
	    !sstreq ("!="))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if (match ("==")) {
			gpush ();
			if (heir6 (&lval2))
				rvalue (&lval2);
			geq ();
		} else if (match ("!=")) {
			gpush ();
			if (heir6 (&lval2))
				rvalue (&lval2);
			gne ();
		} else
			return (0);
	}
}

int heir6 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir7 (lval);
	blanks ();
	if (!sstreq ("<") &&
	    !sstreq ("<=") &&
	    !sstreq (">=") &&
	    !sstreq (">"))
		return (k);
	if (sstreq ("<<") || sstreq (">>"))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if (match ("<=")) {
			gpush ();
			if (heir7 (&lval2))
				rvalue (&lval2);
			if (lval->ptr_type || lval2.ptr_type) {
				gule ();
				continue;
			}
			gle ();
		} else if (match (">=")) {
			gpush ();
			if (heir7 (&lval2))
				rvalue (&lval2);
			if (lval->ptr_type || lval2.ptr_type) {
				guge ();
				continue;
			}
			gge ();
		} else if ((sstreq ("<")) &&
			   !sstreq ("<<")) {
			inbyte ();
			gpush ();
			if (heir7 (&lval2))
				rvalue (&lval2);
			if (lval->ptr_type || lval2.ptr_type) {
				gult ();
				continue;
			}
			glt ();
		} else if ((sstreq (">")) &&
			   !sstreq (">>")) {
			inbyte ();
			gpush ();
			if (heir7 (&lval2))
				rvalue (&lval2);
			if (lval->ptr_type || lval2.ptr_type) {
				gugt ();
				continue;
			}
			ggt ();
		} else
			return (0);
		blanks ();
	}
}

int heir7 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir8 (lval);
	blanks ();
	if (  (!sstreq (">>") && !sstreq ("<<") ) ||
		sstreq(">>=") || sstreq("<<=") )
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if (sstreq(">>") && ! sstreq(">>=")) {
			inbyte(); inbyte();
			gpush ();
			if (heir8 (&lval2))
				rvalue (&lval2);
			gasr ();
		} else if (sstreq("<<") && ! sstreq("<<=")) {
			inbyte(); inbyte();
			gpush ();
			if (heir8 (&lval2))
				rvalue (&lval2);
			gasl ();
		} else
			return (0);
		blanks();
	}
}

int heir8 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir9 (lval);
	blanks ();
	if ( ( (ch () != '+') && (ch () != '-') ) || (nch() == '=') )
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if (match ("+")) {
			gpush ();
			if (heir9 (&lval2))
				rvalue (&lval2);
			/* if left is pointer and right is int, scale right */
			if (dbltest (lval, &lval2))
				gaslint ();
			/* will scale left if right int pointer and left int */
			gadd (lval,&lval2);
			result (lval, &lval2);
		} else if (match ("-")) {
			gpush ();
			if (heir9 (&lval2))
				rvalue (&lval2);
			/* if dbl, can only be: pointer - int, or
						pointer - pointer, thus,
				in first case, int is scaled up,
				in second, result is scaled down. */
			if (dbltest (lval, &lval2))
				gaslint ();
			gsub ();
			/* if both pointers, scale result */
			if ((lval->ptr_type == CINT) && (lval2.ptr_type == CINT)) {
				gasrint(); /* divide by intsize */
			}
			result (lval, &lval2);
		} else
			return (0);
	}
}

int heir9 (expr_data_t *lval)
{
	int	k;
	expr_data_t lval2;

	k = heir10 (lval);
	blanks ();
	if (((ch () != '*') && (ch () != '/') &&
		(ch () != '%')) || (nch() == '='))
		return (k);
	if (k)
		rvalue (lval);
	FOREVER {
		if (match ("*")) {
			gpush ();
			if (heir10 (&lval2))
				rvalue (&lval2);
			gmult ();
		} else if (match ("/")) {
			gpush ();
			if (heir10 (&lval2))
				rvalue (&lval2);
			gdiv ();
		} else if (match ("%")) {
			gpush ();
			if (heir10 (&lval2))
				rvalue (&lval2);
			gmod ();
		} else
			return (0);
	}
}

int heir10 (expr_data_t *lval)
{
	int	k;
	char	*ptr;

	if (match ("++")) {
		indflg = 0;
		if ((k = heir10 (lval)) == 0) {
			needlval ();
			return (0);
		}
		if (lval->type)
			gpush ();
		rvalue (lval);
		ginc (lval);
		store (lval);
		return (0);
	} else if (match ("--")) {
		indflg = 0;
		if ((k = heir10 (lval)) == 0) {
			needlval ();
			return (0);
		}
		if (lval->type)
			gpush ();
		rvalue (lval);
		gdec (lval);
		store (lval);
		return (0);
	} else if (match ("-")) {
		indflg = 0;
		k = heir10 (lval);
		if (k)
			rvalue (lval);
		gneg ();
		return (0);
	} else if (match ("~")) {
		indflg = 0;
		k = heir10 (lval);
		if (k)
			rvalue (lval);
		gcom ();
		return (0);
	} else if (match ("!")) {
		indflg = 0;
		k = heir10 (lval);
		if (k)
			rvalue (lval);
		glneg ();
		return (0);
	} else if (ch()=='*' && nch() != '=') {
		inbyte();
		indflg = 1;
		k = heir10 (lval);
		indflg = 0;
		ptr = lval->symbol;
		/* vram */
		if (ptr && !strcmp(ptr, "vram")) {
			lval->ptr_type = 0;
			return (1);
		}
		if (k)
			rvalue (lval);
		if ( (ptr = lval->symbol) )
			lval->type = ptr[TYPE];
		else
			lval->type = CINT;
		lval->ptr_type = 0;  /* flag as not pointer or array */
		return (1);
	} else if (ch()=='&' && nch()!='&' && nch()!='=') {
		indflg = 0;
		inbyte();
		k = heir10 (lval);
		if (k == 0) {
			error ("illegal address");
			return (0);
		}
		if (lval->symbol) {
			ptr = lval->symbol;
			lval->ptr_type = ptr[TYPE];
		}
		if (lval->type)
			return (0);
		/* global and non-array */
		ptr = lval->symbol;
		immed (T_SYMBOL, (DATA){.ptr=ptr});
		lval->type = ptr[TYPE];
		return (0);
	} else {
		k = heir11 (lval);
		ptr = lval->symbol;
		if (match ("++")) {
			if (k == 0) {
				needlval ();
				return (0);
			}
			/* vram */
			if (ptr && !strcmp(ptr, "vram"))
				return (0);
			if (lval->type)
				gpush ();
			rvalue (lval);
			ginc (lval);
			store (lval);
			gdec (lval);
			return (0);
		} else if (match ("--")) {
			if (k == 0) {
				needlval ();
				return (0);
			}
			/* vram */
			if (ptr && !strcmp(ptr, "vram")) {
				error("can't decrement vram pointer");
				return (0);
			}
			if (lval->type)
				gpush ();
			rvalue (lval);
			gdec (lval);
			store (lval);
			ginc (lval);
			return (0);
		} else
			return (k);
	}
}

int heir11 (expr_data_t *lval)
{
	int	k;
	char	*ptr;

	k = primary (lval);
	ptr = lval->symbol;
	blanks ();
	if ((ch () == '[') || (ch () == '(')) {
		for (;;) {
			if (match ("[")) {
				if (ptr == 0) {
					error ("can't subscript");
					junk ();
					needbrack ("]");
					return (0);
				}
				else if (ptr[IDENT] == POINTER)
					rvalue (lval);
				else if (ptr[IDENT] != ARRAY) {
					error ("can't subscript");
					k = 0;
				}
				if (!ptr[FAR])
					gpush ();
				expression (YES);
				needbrack ("]");
				if (ptr[TYPE] == CINT)
					gaslint ();
				if (!ptr[FAR])
					gadd (NULL,NULL);
				lval->symbol = NULL;
				lval->type = ptr[TYPE];
				lval->ptr_type = 0;//VARIABLE; /* David, bug patch ?? */
				lval->array = ptr[FAR] ? ptr : NULL;
				k = 1;
			}
			else if (match ("(")) {
				if (ptr == 0) {
					error("invalid or unsupported function call");
					callfunction (0);
				}
				else if (ptr[IDENT] != FUNCTION) {
					if (strcmp(ptr, "vram") == 0)
						callfunction (ptr);
					else {
						if (ptr[FAR]) {
							lval->array = ptr;
							immed (T_VALUE, (DATA){.integer=0});
						}
						rvalue (lval);
						callfunction (0);
					}
				} else
					callfunction (ptr);
				lval->symbol = NULL;
				k = 0;
			}
			else
				return (k);
		}
	}
	if (ptr == 0)
		return (k);
	if (ptr[IDENT] == FUNCTION) {
		immed (T_SYMBOL, (DATA){.ptr=ptr});
		return (0);
	}
	return (k);
}

void store (expr_data_t *lval)
{
	if (lval->array) {
		/* far arrays (or special arrays) */
		if (!strcmp (lval->array, "vdc"))
			putio (lval->array);
		else if (!strcmp (lval->array, "vram"))
			putvram (lval->array);
		else {
			error ("const arrays can't be written");
			gpop ();
		}
	}
	else {
		/* other */
		if (lval->type != 0)
			putstk (lval->type);
		else {
			if (strcmp(lval->symbol, "vram") == 0)
				out_ins(I_VPUTW, 0, (DATA) {.ptr=NULL});
			else
				putmem (lval->symbol);
		}
	}
}

void rvalue (expr_data_t *lval)
{
	if ((lval->symbol != 0) && (lval->type == 0)) {
		if (strcmp(lval->symbol, "vram") == 0)
			out_ins(I_VGETW, 0, (DATA){.ptr=NULL});
		else
			getmem (lval->symbol);
	}
	else {
		if (lval->array == NULL)
			indirect (lval->type);
		else {
			/* far arrays (or special arrays) */
			if (!strcmp (lval->array, "vdc"))
				getio (lval->array);
			else if (!strcmp (lval->array, "vram"))
				getvram (lval->array);
			else
				farpeek (lval->array);
		}
	}
}

void needlval (void )
{
	error ("must be lvalue");
}

