; note instrument leftVol rightVol effect
; C#4  [0,63]     [0,15]  [0,15]   ????
;
; instrument :
;    flag
;    arpeggio sequence
;    volume sequence left
;    volume sequence right
;    pitch sequence
;
; sequence :
;    length (max 128)
;    loop offset (128 = no loop)
;    data
;
; song speed
;    vsync_ptr:
;        --counter
;        if(counter == 0) {
;                   process next note
;                   counter = speed
;        }
;

    .include "equ.inc"
	.include "macro.inc"
	.include "vdc.inc"
	.include "psg.inc"

;----------------------------------------------------------------------
; System variables
;----------------------------------------------------------------------
	.org $2200
user_jmptbl:            ; user interrupt vectors
irq2_jmp:       .ds 2   ; IRQ2 (BRK instruction and external IRQ)
irq1_jmp:       .ds 2   ; IRQ1 (VDC interrupt)
timer_jmp:      .ds 2   ; TIMER
nmi_jmp:        .ds 2   ; NMI (unused)
vsync_hook:     .ds 2   ; VDC vertical sync routine
hsync_hook:     .ds 2   ; VDC horizontal sync rountine
soft_reset:		.ds 2	; soft reset

;----------------------------------------------------------------------
; ZP variables declaration
;----------------------------------------------------------------------
	.zp  
__tmp          ds    2
__ptr          ds    2

; current speed
; current tempo
;<jsr> total speed = (tempo * 6) / speed
;<jsr> that means tempo is correct at speed of 6, setting it to 3 will double the tempo

		.include "interrupts.asm"       
 ;       .include "msx.asm"
        .include "gfx.asm"
        
        .code
;----------------------------------------------------------------------
; Main program
;----------------------------------------------------------------------
main:

    st0    #$05  ; set vdc control register
    lda    #%11001100  ; enable vdc interupts
    stz	   video_data_l
    sta    <vdc_crl
    st2    #$00  ; sprite and bg are disabled
	
	stz <irq_m
		
	set_vec	#VSYNC, dummy
	vec_on #VSYNC
	
	lda		#$ff
	sta		scr_height
	
	scroll #2, #0, #0, #$f0, #$fa, #3
	scroll #1, #0, #0, #$c0, #$ca, #3
	scroll #3, #0, #0, #$b0, #$ba, #3
	scroll #0, #0, #0, #$a0, #$aa, #3
	
	
	cli
	
loop:

	jsr process_scroll

    bra    loop

    rts ; just to be sure :p


;----------------------------------------------------------------------
; Dummy interrupt
dummy:
	
	pha
	phx
	phy
	
	lda #$ee
	sta <__tmp
	
	ply
	plx
	pla
	
	rts

;----------------------------------------------------------------------
; Data:
;----------------------------------------------------------------------
	.data
	.bank 1
        .org $C000

        .include "instrument.inc"

        dummyPalette:
    .dw $0007, $0038, $0000, $0000, $0000, $0000, $0000, $0000
    .dw $0000, $0000, $0000, $0000, $0000, $0000, $0000, $ffff
